/* Dati dei pezzi per Dilemma */

#include <stdio.h>
#include <graphics.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>

#define  NPEZZI         12
#define  SCRLX         640
#define  SCRLY         350
/* dimensione di una singola cella */
#define  DIMCEL         14
#define  MAXGRDX        15
#define  MAXGRDY        10
/* offset x puntamento cursore */
#define  OF_XY          29
/* costanti per mouse */
#define  INT_MOUSE    0x33
#define  MOUS_RESET      0
#define  MOUS_EN_CUR     1
#define  MOUS_DI_CUR     2
#define  MOUS_XY_TAS     3
#define  MOUS_BUTTON     5
/* costanti per movimento pezzo */
#define  NO_PEZZO       -1
#define  MAX_X_SF       DIMCEL * 5 - 1
#define  MAX_Y_SF       DIMCEL * 5 - 1
/* coordinate dei pulsanti */
#define  AMPIEZX       130
#define  AMPIEZY        70
#define  XMIRROR        20
#define  YMIRROR        95
#define  XROTATE        20
#define  YROTATE       185
#define  XFLIP         SCRLX - 150
#define  YFLIP          95
#define  XPIECE        XFLIP
#define  YPIECE        185



void Inizialize (void);
void InizializeGet (void);
void Mouse (int  funzione);
void SettaPagina ( void );
void InizializeGrid (int lx, int ly);
void MuoviPezzo(int pz, int rot, int x, int y);
void Bottone(int x, int y, int lx, int ly, int color);
int  ContLim (int x, int y, int cx, int cy);
void DrawIntest( void );
void DrawMirror( void );
void DrawFlip( void );
void DrawRotate( void );
void DrawPiece( void );
void DrawPezzi( void );

/* coordinate degli angoli della griglia */
int   glx, gty, grx, gby;
/* necessaria per interrupt mouse definita in dos.h */
static struct REGPACK   reg;


main()
{
  char  flip[]   = {4, 5, 6, 7, 0, 1, 2, 3};
  char  mirror[] = {6, 7, 4, 5, 2, 3, 0, 1};
  char  rotate[] = {1, 2, 3, 0, 5, 6, 7, 4};
  int   tmp = 0;
  int   pz, rot = 0;
  /* coordinate mouse - b = tasto mouse*/
  int  x, y, b;

  Inizialize ();

  while (1)
  {
    if (tmp++ == 400)
    {
      Mouse ( MOUS_XY_TAS);
      x = reg.r_cx;
      y = reg.r_dx;
      Mouse ( MOUS_BUTTON );
      b = reg.r_bx;

      /* controlla se e' stato premuto un pulsante */
      if ( b == 1 )
      {
	if (ContLim(x, y, XMIRROR, YMIRROR))
	   rot = mirror[rot];
	if (ContLim(x, y, XROTATE, YROTATE))
	   rot = rotate[rot];
	if (ContLim(x, y, XFLIP, YFLIP))
	   rot = flip[rot];
	if (ContLim(x, y, XPIECE, YPIECE))
	   exit(0);
      }

      /* Controlla se si e' nella griglia */
      if (x + OF_XY > glx && x + OF_XY < grx && y + OF_XY > gty && y + OF_XY < gby)
      {
	 x = glx + (x - glx) / DIMCEL * DIMCEL;
	 y = gty + (y - gty) / DIMCEL * DIMCEL;
      }

      /* inserire controllo tasti 3d e prelievo pezzi */
      MuoviPezzo( 0, rot, x, y);
      tmp = 0;
    }
  }
}

/* ************************************************** */

void Inizialize (void)
{
  int   grph_drv, grph_mode;
  int   i = 0;

  grph_drv = EGA;
  grph_mode = EGAHI;
  initgraph(&grph_drv, &grph_mode, "");
  setviewport(0, 0, SCRLX - 1, SCRLY - 1, 0);
  SettaPagina();
  InizializeGet();
  cleardevice();

  settextstyle(SANS_SERIF_FONT, HORIZ_DIR, 0);
  setusercharsize(2, 3, 2, 5);

  while (i++ < 2)
  {
    SettaPagina();
    /* colora lo sfondo di GREEN */
    setfillstyle( SOLID_FILL, GREEN);
    bar(0,0, SCRLX -1, SCRLY -1);
    InizializeGrid(15, 10);
    DrawIntest();
    DrawMirror();
    DrawFlip();
    DrawRotate();
    DrawPiece();
    DrawPezzi();
  }
  Mouse( MOUS_RESET );
  Mouse( MOUS_EN_CUR );

}

void Mouse (int  funzione)
{
  reg.r_ax = funzione;
  intr(INT_MOUSE, &reg);
}

/* Scambia le 2 pagine video usate - 1 visualizzata e 1 x stampare */
void SettaPagina( void )
{
  static int   pg = 0;

  setvisualpage( pg );
  pg = !pg && 1;
  setactivepage( pg );
}
/* controlla limiti dei pulsanti */
int  ContLim (int x, int y, int cx, int cy)
{
  if (x - cx < AMPIEZX && x - cx > 0 && y - cy < AMPIEZY && y - cy > 0)
     return (1);
  else
     return (0);
}

void DrawIntest( void )
{
  int   x, y, lx, ly;

  settextjustify(CENTER_TEXT, TOP_TEXT);
  lx = 300;
  ly = 70;
  x = (SCRLX - lx) / 2;
  y = 5;
  /*  tempo */
  Bottone (x, y, lx, ly, BLUE);
  setcolor(LIGHTRED);
  outtextxy(x + lx / 2, y + 5, "INDICATORE DEL BONUS");
  /*  vite */
  lx = 150;
  x = 10;
  Bottone (x, y, lx, ly, BLUE);
  setcolor(LIGHTRED);
  outtextxy(x + lx / 2, y + 5, "VITE");
  /*  livelli */
  lx = 150;
  x = SCRLX - (lx + x);
  Bottone (x, y, lx, ly, BLUE);
  setcolor(LIGHTRED);
  outtextxy(x + lx / 2, y + 5, "LIVELLO");
}

void DrawMirror( void )
{
  settextjustify(CENTER_TEXT, BOTTOM_TEXT);
  Bottone(XMIRROR, YMIRROR, AMPIEZX, AMPIEZY, MAGENTA);
  setcolor(YELLOW);
  outtextxy(XMIRROR + AMPIEZX /2, YMIRROR + AMPIEZY - 5, "SPECCHIO");
}

void DrawRotate( void )
{
  settextjustify(CENTER_TEXT, BOTTOM_TEXT);
  Bottone(XROTATE, YROTATE, AMPIEZX, AMPIEZY, CYAN);
  setcolor(YELLOW);
  outtextxy(XROTATE + AMPIEZX / 2, YROTATE + AMPIEZY - 5, "RUOTA");
}

void DrawFlip( void )
{
  settextjustify(CENTER_TEXT, BOTTOM_TEXT);
  Bottone(XFLIP, YFLIP, AMPIEZX, AMPIEZY, LIGHTBLUE);
  setcolor(YELLOW);
  outtextxy(XFLIP + AMPIEZX / 2, YFLIP + AMPIEZY - 5, "FLIP");
}

void DrawPiece( void )
{
  settextjustify(CENTER_TEXT, BOTTOM_TEXT);
  Bottone(XPIECE, YPIECE, AMPIEZX, AMPIEZY, BROWN);
  setcolor(YELLOW);
  outtextxy(XPIECE + AMPIEZX / 2, YPIECE + AMPIEZY - 5, "DEPOSITA");
}

void DrawPezzi( void )
{
  int   i, inc;
  int x, y, x1, y1;

  settextjustify(CENTER_TEXT, BOTTOM_TEXT);
  x = 8;
  y = SCRLY - 78;
  x1 = SCRLX - x - 1;
  y1 = SCRLY - 9;
  setcolor(LIGHTBLUE);
  rectangle (x, y, x1, y1);

  inc = (x1 - x) / 12 + 1;
  for(i = x; i < x1; i += inc)
  {
    setcolor( LIGHTBLUE );
    line (i, y, i, y1);
    setcolor (WHITE);
    outtextxy(i + inc / 2, y1 - 10, "0");
  }

}


/* buffer per quadrato e sfondo griglia */
void   *buf[NPEZZI + 1];
/* puntatore ad un buffer per lo sfondo sotto il pezzo */
void   *buf_sf;

/* memorizza i quadrati con diversi colori */
void InizializeGet (void)
{

  int  dim, i;
  int  color[] = {BROWN, LIGHTGRAY, LIGHTBLUE, LIGHTMAGENTA, LIGHTGREEN,
		  RED, CYAN, LIGHTRED, YELLOW, MAGENTA, BLUE, LIGHTCYAN,
		  GREEN}; /* sfondo griglia GREEN = elemento 12 */

  /* dimensione massima del quadrato */
  dim = imagesize (0, 0, DIMCEL, DIMCEL);

  for (i = 0; i <= NPEZZI; ++i)
  {
    buf[i] = malloc( dim );
    Bottone (0, 0, DIMCEL, DIMCEL, color[i]);
    getimage (0, 0, DIMCEL - 1, DIMCEL - 1, buf[i]);
  }

  dim = imagesize (0, 0, MAX_X_SF, MAX_Y_SF);
  buf_sf = malloc( dim );

}

/* stampa griglia */
void InizializeGrid (int lx, int ly)
/* lx e ly ampiezza della griglia in unita' */
{
  /* dimensione massime  15*10 */
  int  gmlx = (SCRLX - MAXGRDX * DIMCEL) / 2;
  int  gmrx = (SCRLX + MAXGRDX * DIMCEL) / 2 - 1;
  int  gmty = (SCRLY - MAXGRDY * DIMCEL) / 2;
  int  gmby = (SCRLY + MAXGRDY * DIMCEL) / 2 - 1;
  int  ix, iy;

  /* dimensione max grid - publiche */
  glx = (SCRLX - lx * DIMCEL) / 2;
  grx = (SCRLX + lx * DIMCEL) / 2 - 1;
  gty = (SCRLY - ly * DIMCEL) / 2;
  gby = (SCRLY + ly * DIMCEL) / 2 - 1;

   for (ix = 0; ix < lx * DIMCEL; ix += DIMCEL)
     for (iy = 0; iy < ly * DIMCEL; iy += DIMCEL)
       putimage (glx + ix, gty + iy, buf[12], COPY_PUT);

   setcolor( LIGHTGREEN );
   line (gmlx - DIMCEL, gty - DIMCEL, gmrx + DIMCEL, gty - DIMCEL);
   line (gmlx - DIMCEL, gby + DIMCEL, gmrx + DIMCEL, gby + DIMCEL);
   line (glx - DIMCEL, gmty - DIMCEL, glx - DIMCEL, gmby + DIMCEL);
   line (grx + DIMCEL, gmty - DIMCEL, grx + DIMCEL, gmby + DIMCEL);

}


void MuoviPezzo(int pz, int rot, int x, int y)
/* se pz = NO_PEZZO ripristina sfondo */
{
  /* composti da una sequenza di x - y   x 5 */

  static char  pezzo[] [10] = {

	/* pezzo 0 */
	{0, 1, 1, 1, 1, 2, 2, 2, 3, 2},
	{2, 0, 2, 1, 1, 1, 1, 2, 1, 3},
	{0, 1, 1, 1, 2, 1, 2, 2, 3, 2},
	{2, 0, 2, 1, 2, 2, 1, 2, 1, 3},

	{0, 2, 1, 2, 1, 1, 2, 1, 3, 1},
	{1, 0, 1, 1, 2, 1, 2, 2, 2, 3},
	{0, 2, 1, 2, 2, 2, 2, 1, 3, 1},
	{1, 0, 1, 1, 1, 2, 2, 2, 2, 3},

	/* pezzo 1 */
	{0, 1, 0, 2, 1, 2, 2, 2, 3, 2},
	{1, 0, 2, 0, 1, 1, 1, 2, 1, 3},
	{0, 1, 1, 1, 2, 1, 3, 1, 3, 2},
	{2, 0, 2, 1, 2, 2, 2, 3, 1, 3},

	{0, 2, 0, 1, 1, 1, 2, 1, 3, 1},
	{1, 0, 2, 0, 2, 1, 2, 2, 2, 3},
	{0, 2, 1, 2, 2, 2, 3, 2, 3, 1},
	{1, 0, 1, 1, 1, 2, 1, 3, 2, 3},

	/* pezzo 7 */
	{0, 2, 1, 2, 2, 2, 3, 2, 4, 2},
	{2, 0, 2, 1, 2, 2, 2, 3, 2, 4},
	{0, 2, 1, 2, 2, 2, 3, 2, 4, 2},
	{2, 0, 2, 1, 2, 2, 2, 3, 2, 4},
	{0, 2, 1, 2, 2, 2, 3, 2, 4, 2},
	{2, 0, 2, 1, 2, 2, 2, 3, 2, 4},
	{0, 2, 1, 2, 2, 2, 3, 2, 4, 2},
	{2, 0, 2, 1, 2, 2, 2, 3, 2, 4},

	/* pezzo 8 */
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2}

	};

  /* coordinate precedenti del pezzo */
  static int   cpx = -1, cpy = -1;
  /* pezzo precedente se -1 nessun pezzo */
  static int   ppz = -2, ppos = 0;
  /* se = 1 nuova posizione pezzo */
  static int   npz = 0;

  static int  i, pos;

  pos = pz * 8 + rot;

  if (x > SCRLX - DIMCEL * 5)
     x = SCRLX - DIMCEL * 5;

  if (x != cpx || y != cpy || pos != ppos)
  {
    npz = 1;
    if ( pz != ppz )
       Mouse ( MOUS_DI_CUR );
  }
  else
    npz = 0;

  if (npz == 1 && pz > NO_PEZZO)
  {
    for (i = 0; i < 10; i += 2)
      putimage (x + pezzo[pos][i] * DIMCEL, y + pezzo[pos][i + 1] * DIMCEL, buf[pz], COPY_PUT);
    SettaPagina();
  }

  if ((pz == NO_PEZZO || npz == 1) && ppz != -2 )
    putimage(cpx, cpy, buf_sf, COPY_PUT);

  if (pz > NO_PEZZO)
  {
    if (pz != ppz || npz == 1)
    {
      getimage(x, y, x + MAX_X_SF, y + MAX_X_SF, buf_sf);
      cpx = x;
      cpy = y;
      ppz = pz;
      ppos = pos;
    }
  }
  else
    Mouse ( MOUS_EN_CUR);

}

void Bottone(int x, int y, int lx, int ly, int color)
/* stampa un singolo bottone con un colore dato
   x, y coordinate lx, ly ampiezza del bottone */
{

 --lx;
 --ly;
 setcolor( color );
 setfillstyle( SOLID_FILL, color);
 bar(x + 2, y + 2, x + lx - 2, y + ly - 2);

 setcolor ( BLACK );
 line(x + 1, y + 1, x + lx - 1, y + 1);
 line(x + 1, y + 2, x + 1, y + ly - 2);
 line(x + lx - 1, y, x, y);
 line(x, y + 1, x, y + ly - 1);

 if (color > 7)
   color = WHITE;
 else
   color += 8;

 setcolor( color );
 line(x + 1, y + ly - 1, x + lx - 1, y + ly - 1);
 line(x + lx - 1, y + ly - 2, x + lx - 1, y + 1);
 line(x, y + ly, x + lx, y + ly);
 line(x + lx, y + ly - 1, x + lx, y);

}
