/*****************/
/* D I L E M M A */
/*****************/
/* data 18/11/92, 30/11/92, 11/05/96*/

#include <stdio.h>
#include <graphics.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <process.h>

#define  PROGRAMMA      "GO.EXE"

#define  NPEZZI         12
#define  SCRLX         640
#define  SCRLY         350
/* dimensione di una singola cella */
#define  DIMCEL         14
/* dimensione massima della griglia */
#define  MAXGRDX        15
#define  MAXGRDY        10
/* offset y della griglia spostamento alto/basso rispetto al centro */
#define  OFFGRDY        12
/* distanza delle linee dalla griglia */
#define  OFFGRDLINE     10
/* costanti per mouse */
#define  INT_MOUSE    0x33
#define  MOUS_RESET      0
#define  MOUS_XY_TAS     3
#define  MOUS_BUTTON     5
#define  MOUS_SETLOC     4
#define  MOUS_RANGEX	 7
#define  MOUS_RANGEY     8
/* costanti per movimento pezzo */
#define  NO_PEZZO       -1
#define  MAX_X_SF       DIMCEL * 5 - 1
#define  MAX_Y_SF       DIMCEL * 5 - 1
/* coordinate dei pulsanti */
#define  AMPIEZX       130
#define  AMPIEZY        75
#define  XMIRROR        20
#define  YMIRROR        90
#define  XROTATE        20
#define  YROTATE       185
#define  XFLIP         SCRLX - 150
#define  YFLIP          90
#define  XPIECE        XFLIP
#define  YPIECE        185
/* altezza dell'intestazione e distanza dal bordo superiore */
#define  INTEST_LY      75
#define  INTEST_DY       5
/* posizione del punteggio */
#define  PUNTEG_X       SCRLX / 2 + 24
#define  PUNTEG_Y       INTEST_DY + INTEST_LY + 5
/* coordinate della maschera dei pezzi */
#define  MPZLX           8
#define  MPZTY          SCRLY - 78
#define  MPZRX          SCRLX - MPZLX - 1
#define  MPZBY          SCRLY - 9
/* offset delle scritte */
#define  OF_TXT         7
/* ampiezza in pixel dell' ombra dei pulsanti, grid, pezzo, pezzi in basso, */
#define  AMP_PULS	2
#define  AMP_GRID	2
#define  AMP_PEZZ	2
#define  AMP_PZ12	2
/* larghezza e altezza di un singolo segmento dei Numeri e spessore
   distanza x e y tra segmenti e offset x e y ombra */
#define  NUM_SLX        20
#define  NUM_SHY        10
#define  NUM_SDX         1
#define  NUM_SDY         1
#define  NUM_SOX         3
#define  NUM_SOY         3
/* offset dell' ombra del cursore */
#define  PUNT_OFO        3
/* distanza fra un numero e l'altro */
#define  NUM_DIST      6 + NUM_SDX * 2 + NUM_SLX + 30
/* coordinate tempo */
#define  COORD_VIX      40
#define  COORD_TMX     245
#define  COORD_LIX     509
#define  COORD_TMY      27
/* costanti per setta pagina */
#define  MOUS_PEZZ	 0
#define  MOUS_CURS	 1
/* costante per definire sfondo griglia colore */
#define  SFONDO         12
/* la posizione nella griglia e' vuota */
#define  GRID_VUOTA    255
/* tempo di partenza */
#define  TEMPO_INIZ    999
/* punto di uscita (punto bianco sullo schermo) */
#define  EXIT_CY       0
/* offset da applicare alla stringa del nome sottrarre */
#define  OFF_NAME      137
/* scritto: Ballabio Alberto */
#define  NAME         ""
/* scritto: by BA , l'OFF_NAME da utilizzare e 137 - 10 */
#define  NAMEBA		  ""

/* PROTOTIPI */
void Cambia( void );
void Inizialize (void);
void InizializeGet (void);
void Mouse (int  funzione);
void SettaPagina ( void );
void InizializeGrid (int level);
void MuoviPezzo( int vis_tempo, int tempo );
void Bottone(int x, int y, int lx, int ly, int color, int ombra, int ampiezza);
int  ContLim (int x, int y, int cx, int cy);
void DrawIntest( void );
void DrawMirror( void );
void DrawFlip( void );
void DrawRotate( void );
void DrawPiece( void );
void DrawPezzi( void );
void DisegnaPezzo(int x, int y, int inc);
void DrawPunteggio( void );
void AggiornaDatiPezzo( int pos );
void CambiaLivello( int liv );
void CancellaVetGrid ( void );
int  CercaPezzo( void );
int  PosizionaPezzo( int pz);
void Scrivi(int tx, int ty, char *stringa, int color);
void Stampa_pz_disp( int r );
void PrintPezzo(int pezzo, int colore);
void CreaNumeri (void );
void DrawSegOrr (int px, int py);
void DrawSegVer( int px, int py );
void StampaNumeri (int px, int py, int numero, int num_cifre);
void ModificaPunteggio(int *punteggio, int tempo);

/* vettore dati livelli */
/*  nump0, nump1, nump2 .... nump11, dimx, dimy  */
struct liv {
  char  *np;
  int	lx;
  int   ly;
} livello[] = {
	/*
	{"\2\2\2\2\2\2\2\2\2\2\2\2", 15, 10},
	*/
	{"\0\1\0\0\2\1\0\0\0\0\1\0", 5, 5},
	{"\0\2\0\0\0\0\1\0\1\1\0\0", 5, 5},
	{"\0\0\2\1\0\0\1\1\0\0\0\1", 6, 5},
	{"\1\0\0\2\0\1\0\0\0\0\1\1", 5, 6},
	{"\1\1\2\2\0\0\0\1\0\0\0\0", 7, 5},

	{"\2\2\0\0\0\0\0\0\0\2\1\0", 5, 7},
	{"\0\2\0\2\0\2\0\0\1\0\0\1", 8, 5},
	{"\1\0\1\1\1\0\0\1\0\1\1\1", 5, 8},
	{"\1\1\1\1\1\0\1\2\0\0\0\1", 9, 5},
	{"\1\2\1\1\0\1\0\0\2\1\0\0", 5, 9},

	{"\2\0\1\2\1\0\2\1\0\1\0\0",10, 5},
	{"\0\2\0\1\2\1\0\1\0\3\0\0", 5,10},
	{"\2\1\0\1\0\0\3\2\3\0\0\0",10, 6},
	{"\3\2\0\2\1\1\1\1\0\0\1\0", 6,10},
	{"\1\1\2\2\1\1\0\3\0\1\1\1",10, 7},

	{"\4\2\2\0\1\2\0\1\1\0\0\1", 7,10},
	{"\2\2\1\2\4\0\1\1\0\0\2\1",10, 8},
	{"\1\4\1\0\0\1\1\1\3\0\1\3", 8,10},
	{"\3\1\2\3\1\1\1\1\0\1\1\3",10, 9},
	{"\2\1\1\1\1\2\2\3\1\1\1\2", 9,10},

	{"\1\5\3\2\2\0\1\1\0\5\0\0",10,10},
	{"\4\1\1\1\3\1\3\0\3\1\0\2",10,10},
	{"\2\3\4\2\3\4\0\1\1\0\1\1",11,10},
	{"\1\2\1\3\1\1\2\2\1\2\3\3",11,10},
	{"\1\1\2\4\2\2\0\1\9\2\0\0",12,10},

	{"\3\5\3\2\1\3\2\2\1\2\1\1",13,10},
	{"\5\4\1\0\2\2\2\2\1\2\2\3",13,10},
	{"\4\3\3\5\3\2\0\1\2\2\2\1",14,10},
	{"\3\4\2\3\2\2\2\2\2\4\2\2",15,10},
	{"\0\1\3\2\2\2\4\1\2\4\3\6",15,10}
	};

  /* composti da una sequenza di x - y   x 5 */

  char  pezzo[] [10] = {

	/* pezzo 0 */
	{0, 0, 1, 0, 1, 1, 2, 1, 3, 1},
	{1, 0, 1, 1, 0, 1, 0, 2, 0, 3},
	{0, 0, 1, 0, 2, 0, 2, 1, 3, 1},
	{1, 0, 1, 1, 1, 2, 0, 2, 0, 3},

	{0, 1, 1, 1, 1, 0, 2, 0, 3, 0},
	{0, 0, 0, 1, 1, 1, 1, 2, 1, 3},
	{0, 1, 1, 1, 2, 1, 2, 0, 3, 0},
	{0, 0, 0, 1, 0, 2, 1, 2, 1, 3},

	/* pezzo 1 */
	{0, 0, 0, 1, 1, 1, 2, 1, 3, 1},
	{0, 0, 1, 0, 0, 1, 0, 2, 0, 3},
	{0, 0, 1, 0, 2, 0, 3, 0, 3, 1},
	{1, 0, 1, 1, 1, 2, 1, 3, 0, 3},

	{0, 1, 0, 0, 1, 0, 2, 0, 3, 0},
	{0, 0, 1, 0, 1, 1, 1, 2, 1, 3},
	{0, 1, 1, 1, 2, 1, 3, 1, 3, 0},
	{0, 0, 0, 1, 0, 2, 0, 3, 1, 3},

	/* pezzo 2 */
	{0, 1, 1, 1, 2, 1, 3, 1, 2, 0},
	{0, 0, 0, 1, 0, 2, 0, 3, 1, 2},
	{0, 0, 1, 0, 2, 0, 3, 0, 1, 1},
	{0, 1, 1, 0, 1, 1, 1, 2, 1, 3},

	{0, 0, 1, 0, 2, 0, 3, 0, 2, 1},
	{1, 0, 1, 1, 1, 2, 1, 3, 0, 2},
	{0, 1, 1, 1, 2, 1, 3, 1, 1, 0},
	{0, 0, 0, 1, 0, 2, 0, 3, 1, 1},

	/* pezzo 3 */
	{0, 0, 1, 0, 2, 0, 0, 1, 1, 1},
	{0, 0, 1, 0, 0, 1, 1, 1, 1, 2},
	{1, 0, 2, 0, 0, 1, 1, 1, 2, 1},
	{0, 0, 0, 1, 1, 1, 0, 2, 1, 2},

	{0, 0, 1, 0, 0, 1, 1, 1, 2, 1},
	{0, 0, 1, 0, 0, 1, 1, 1, 0, 2},
	{0, 0, 1, 0, 2, 0, 1, 1, 2, 1},
	{1, 0, 0, 1, 1, 1, 0, 2, 1, 2},

	/* pezzo 4 */
	{0, 0, 1, 0, 2, 0, 0, 1, 0, 2},
	{0, 0, 1, 0, 2, 0, 2, 1, 2, 2},
	{2, 0, 2, 1, 2, 2, 1, 2, 0, 2},
	{0, 0, 0, 1, 0, 2, 1, 2, 2, 2},

	{0, 0, 0, 1, 0, 2, 1, 2, 2, 2},
	{0, 0, 1, 0, 2, 0, 0, 1, 0, 2},
	{0, 0, 1, 0, 2, 0, 2, 1, 2, 2},
	{2, 0, 2, 1, 2, 2, 1, 2, 0, 2},

	/* pezzo 5 */
	{0, 0, 1, 0, 2, 0, 0, 1, 2, 1},
	{0, 0, 1, 0, 1, 1, 1, 2, 0, 2},
	{0, 0, 2, 0, 0, 1, 1, 1, 2, 1},
	{0, 0, 1, 0, 0, 1, 0, 2, 1, 2},

	{0, 0, 2, 0, 0, 1, 1, 1, 2, 1},
	{0, 0, 1, 0, 0, 1, 0, 2, 1, 2},
	{0, 0, 1, 0, 2, 0, 0, 1, 2, 1},
	{0, 0, 1, 0, 1, 1, 1, 2, 0, 2},

	/* pezzo 6 */
	{0, 0, 0, 1, 0, 2, 1, 1, 2, 1},
	{0, 0, 1, 0, 2, 0, 1, 1, 1, 2},
	{0, 1, 1, 1, 2, 0, 2, 1, 2, 2},
	{1, 0, 1, 1, 0, 2, 1, 2, 2, 2},

	{0, 0, 0, 1, 0, 2, 1, 1, 2, 1},
	{0, 0, 1, 0, 2, 0, 1, 1, 1, 2},
	{0, 1, 1, 1, 2, 0, 2, 1, 2, 2},
	{1, 0, 1, 1, 0, 2, 1, 2, 2, 2},

	/* pezzo 7 */
	{0, 0, 1, 0, 2, 0, 3, 0, 4, 0},
	{0, 0, 0, 1, 0, 2, 0, 3, 0, 4},
	{0, 0, 1, 0, 2, 0, 3, 0, 4, 0},
	{0, 0, 0, 1, 0, 2, 0, 3, 0, 4},

	{0, 0, 1, 0, 2, 0, 3, 0, 4, 0},
	{0, 0, 0, 1, 0, 2, 0, 3, 0, 4},
	{0, 0, 1, 0, 2, 0, 3, 0, 4, 0},
	{0, 0, 0, 1, 0, 2, 0, 3, 0, 4},

	/* pezzo 8 */
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},

	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 1, 2},

	/* pezzo 9 */
	{0, 0, 1, 0, 1, 1, 2, 1, 1, 2},
	{2, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 1, 2, 2, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 0, 2},

	{1, 0, 1, 1, 2, 1, 1, 2, 0, 2},
	{0, 0, 0, 1, 1, 1, 2, 1, 1, 2},
	{1, 0, 2, 0, 0, 1, 1, 1, 1, 2},
	{1, 0, 0, 1, 1, 1, 2, 1, 2, 2},

	/* pezzo 10 */
	{0, 0, 0, 1, 1, 1, 2, 1, 2, 2},
	{1, 0, 2, 0, 1, 1, 0, 2, 1, 2},
	{0, 0, 0, 1, 1, 1, 2, 1, 2, 2},
	{1, 0, 2, 0, 1, 1, 0, 2, 1, 2},

	{2, 0, 0, 1, 1, 1, 2, 1, 0, 2},
	{0, 0, 1, 0, 1, 1, 1, 2, 2, 2},
	{2, 0, 0, 1, 1, 1, 2, 1, 0, 2},
	{0, 0, 1, 0, 1, 1, 1, 2, 2, 2},

	/* pezzo 11*/
	{0, 0, 1, 0, 1, 1, 2, 1, 2, 2},
	{2, 0, 2, 1, 1, 1, 1, 2, 0, 2},
	{0, 0, 0, 1, 1, 1, 1, 2, 2, 2},
	{1, 0, 2, 0, 1, 1, 0, 1, 0, 2},

	{2, 0, 2, 1, 1, 1, 1, 2, 0, 2},
	{0, 0, 0, 1, 1, 1, 1, 2, 2, 2},
	{1, 0, 2, 0, 1, 1, 0, 1, 0, 2},
	{0, 0, 1, 0, 1, 1, 2, 1, 2, 2},

	};


/* coordinate degli angoli della griglia */
int glx, gty, grx, gby;
/* coordinate massime del pezzo in uso ovvero (mx - my) / 2 */
int plx, ply;
/* offset del pezzo in uso */
int ofx, ofy;
/* necessaria per interrupt mouse definita in dos.h */
struct REGPACK   reg;
/* coordinate puntatore + pulsante mouse */
int x, y, b;
/* pezzo n. + rotazione */
int pz, rot = 0;
/* pagina visualizza */
int pg = 0;
/* dati per griglia */
/* vettore per memorizzare i pezzi nella griglia */
struct griglia {
  unsigned char  gx_pz;
  unsigned char  gy_rot;
  int   px;
  int   py;
} pz_in_grid[MAXGRDX][MAXGRDY];
  /* vettore per contenere i pezzi disponibili in questo livello */
  char pz_in_uso[] = {0,0,0,0,0,0,0,0,0,0,0,0,0};


main(int argc, char *argv[])
{
  char  flip[]   = {4, 7, 6, 5, 0, 3, 2, 1};
  char  mirror[] = {6, 5, 4, 7, 2, 1, 0, 3};
  char  rotate[] = {1, 2, 3, 0, 5, 6, 7, 4};

  /* livello di gioco (1 livello iniziale) */
  int   liv;
  int  vite = 5, tempo;
  unsigned char  old_time = 0;
  struct time *tmp_time;
  /* se != 0 aggiorna il tempo anche se il pezzo non si e' mosso */
  int  vis_tempo = 0;
  /* indica di cambiare il livello se = 1 */
  int   chg_liv = 1;
  /* totale dei pezzi se = largGrid * AltGrid griglia piena */
  int  spazio_occupato;
  int  punteggio = 0;

  int   i, fine = 1;

  unsigned char *s, *sv, *st;

  /* controlla se la stringa passata corrisponde a quella in memoria */
  s = NAME;
  while ( *s != '\0' )
    if ( *s++ != *argv[1]++)
    {
      printf ("\n%s\n\n", " * * *   D I L E M M A   * * *");
      printf ("%s\n\n       ", "               by              ");
      s = NAME;
      while ( *s != '\0' )
      {
		printf ("%c", *s++ - OFF_NAME);
      }
      printf ("\n\n\n%s\n\n", "ATTENZIONE!!!  per giocare lanciare GO.");
	  exit(0);
	}

  /* controlla se gli viene passato un livello valido */
  liv = atoi(argv[2]);
  /* cambia il vettore pezzo in pezzo[t][i] = pezzo[t][i] * DIMCEL */
  Cambia();

  Inizialize ();

  while (fine)
  {
    if (chg_liv == 1)
    {
      i = 0;
      CancellaVetGrid();
      tempo = TEMPO_INIZ;
      while (i++ < 2)
      {
	CambiaLivello(liv - 1);
	Stampa_pz_disp(0);
	StampaNumeri(COORD_VIX, COORD_TMY, vite, 1);
	StampaNumeri(COORD_TMX, COORD_TMY, tempo, 2);
	StampaNumeri(COORD_LIX, COORD_TMY, liv, 1);
	SettaPagina();
      }
      spazio_occupato = 0;
      chg_liv = 0;
      pz = NO_PEZZO;
      if (liv == 31)
	fine = 0;
    }
      Mouse ( MOUS_XY_TAS);
      x = reg.r_cx;
      y = reg.r_dx;
      Mouse ( MOUS_BUTTON );
      b = reg.r_bx;

      /* controlla se e' stato premuto un pulsante */
      if ( b )
      {
	if (pz != NO_PEZZO)
	{
	  if (ContLim(x, y, XMIRROR, YMIRROR))
	     rot = mirror[rot];
	  if (ContLim(x, y, XROTATE, YROTATE))
	     rot = rotate[rot];
	  if (ContLim(x, y, XFLIP, YFLIP))
	     rot = flip[rot];
	  if (ContLim(x, y, XPIECE, YPIECE))
	  {
	    int i = 0;

	    pz_in_uso[pz]++;
	    pz = NO_PEZZO;
	    MuoviPezzo(0, tempo);
	    while (i++ < 2)
	    {
	      SettaPagina();
	      Stampa_pz_disp(0);
	    }
	    AggiornaDatiPezzo(NO_PEZZO);
	    spazio_occupato -= 5;
	  }
	}
	else
	{
	  /* controlla se si e' selezionato un nuovo pezzo */
	  if (x > MPZLX && x < MPZRX && y > MPZTY && y < MPZBY)
	  {
	    int pez;

	    pez = (x - MPZLX + 1) / ((MPZRX - MPZLX + 1) / NPEZZI);
	    if (pz_in_uso[pez])
	    {
	      pz = pez;
	      rot = 0;
	      pz_in_uso[pz]--;
	      Stampa_pz_disp(0);
	      spazio_occupato += 5;
	    }
	  }

	  /*   F I N E   se il puntatore e' nell' angolo 0,0 */
	  if (x == 0 && y == EXIT_CY)
	  {
	     itoa(liv, s, 10);
	     itoa(vite, sv, 10);
	     itoa(tempo, st, 10);
	      execl(PROGRAMMA, "", NAME, s, sv, st, NULL);
	  }
	}
      }
      /* Controlla se si e' nella griglia */
      if (pz != NO_PEZZO &&
	  x + ofx > glx && x - ofx < grx && y + ofy > gty && y - ofy < gby)
      {
	x = glx + ((x - ofx) - glx) / DIMCEL * DIMCEL + ofx;
	y = gty + ((y - ofy) - gty) / DIMCEL * DIMCEL + ofy;
      }

      /* controlla se si puo' depositare il pezzo nella griglia */
      if (b && x-ofx >= glx && y-ofy >= gty && x+ofx-1<=grx && y+ofy-1<=gby)
      {
	if (pz != NO_PEZZO )
	{
	  if (PosizionaPezzo(pz))
	  {
	    PrintPezzo(pz, pz);
	    /* se griglia completa incrementa livello */
	    if (spazio_occupato == livello[liv-1].lx * livello[liv-1].ly)
	    {
	      chg_liv =1;
	      ++liv;
	      ModificaPunteggio(&punteggio, tempo);
	    }
	    pz = NO_PEZZO;
	    /* se finito ultimo termina programma */
	    if (liv == 30 + 1)
	    {
	      printf("%s", "ALBERTO");
	      fine = 0;
	    }
	  }
	}
	else
	  CercaPezzo();
      }

      gettime(tmp_time);
	  if ((*tmp_time).ti_sec != old_time && chg_liv != 1)
      {
	vis_tempo = 1;
	old_time = (*tmp_time).ti_sec;
	tempo--;
	if (tempo < 0)
	{
	  i=0;
	  tempo = TEMPO_INIZ;
	  vite--;
	  if (vite == 0)
	    fine = 0;
	  /* se e' finito il tempo */
	  while (i++ <2)
	  {
	    StampaNumeri(COORD_VIX, COORD_TMY, vite, 1);
	    StampaNumeri(COORD_TMX, COORD_TMY, tempo, 2);
	    StampaNumeri(COORD_LIX, COORD_TMY, liv, 1);
	    SettaPagina();
	  }
	}
      }
      else
	vis_tempo = 0;

      /* ridisegna il pezzo */
      MuoviPezzo(vis_tempo, tempo);

      if (vis_tempo)
	StampaNumeri(COORD_TMX, COORD_TMY, tempo, 2);
  }
}

/* ************************************************************************ */
/* cerca il pezzo nella griglia quando si preme il pulsante */
int CercaPezzo ( void )
{
  int px, py, i, gx, gy;
  unsigned int pos;

  /* trova la cella in cui e' il cursore */
  px = (x - glx) / DIMCEL;
  py = (y - gty) / DIMCEL;
  /* controlla se la cella contiene il numero del pezzo o la cella
     in cui trovarlo */
  if (pz_in_grid[px][py].gx_pz != GRID_VUOTA)
  {
    if (pz_in_grid[px][py].gx_pz >= 100)
    {
      gx = pz_in_grid[px][py].gx_pz - 100;
      gy = pz_in_grid[px][py].gy_rot - 100;
      px = gx;
      py = gy;
    }
    /* ricava pezzo e rotazione */
    pz = pz_in_grid[px][py].gx_pz;
    rot = pz_in_grid[px][py].gy_rot;
    pos = pz * 8 + rot;
    AggiornaDatiPezzo(pos);
    /* ricava coordinate inizio stampa pezzo in grid */
    gx = pz_in_grid[px][py].px;
    gy = pz_in_grid[px][py].py;
    px = gx;
    py = gy;
    /* calcola la posizione del puntatore al centro del pezzo */
    x = px * DIMCEL + glx + ofx;
    y = py * DIMCEL + gty + ofy;
    reg.r_cx = x;
    reg.r_dx = y;
    Mouse(MOUS_SETLOC);
    PrintPezzo(pz, SFONDO);
    for(i=0; i<10; i+=2)
    {
      gx = pezzo[pos][i]/DIMCEL + px;
      gy = pezzo[pos][i+1]/DIMCEL + py;
      pz_in_grid[gx][gy].gx_pz = GRID_VUOTA;
    }
    return(1);
  }
  return(0);
}

/* ************************************************************************ */
/* posiziona il pezzo nella matrice pz_in_grid ritorna 1 se ci sta */
int PosizionaPezzo (int pez)
{
  int i, pos, px, py, gx, gy, tmpx, tmpy;

  pos = pez * 8 + rot;
  px = ((x-ofx)-glx)/DIMCEL;
  py = ((y-ofy)-gty)/DIMCEL;
  for(i=0; i<10; i+=2)
  {
    gx = pezzo[pos][i]/DIMCEL + px;
    gy = pezzo[pos][i+1]/DIMCEL + py;
    if (pz_in_grid[gx][gy].gx_pz != GRID_VUOTA)
      return(0);
  }
  for(i=0; i<10; i+=2)
  {
    gx = pezzo[pos][i]/DIMCEL + px;
    gy = pezzo[pos][i+1]/DIMCEL + py;
    if (i==0)
    {
      tmpx = gx + 100;
      tmpy = gy + 100;
      pz_in_grid[gx][gy].px = px;
      pz_in_grid[gx][gy].py = py;
    }
    pz_in_grid[gx][gy].gx_pz = (i==0 ? pez : tmpx);
    pz_in_grid[gx][gy].gy_rot = (i==0 ? rot : tmpy);
  }
  return (1);
}

/* ************************************************************************ */
void CambiaLivello(int liv)
{
  /* dimensione massime  15*10 */
  int  gmlx = (SCRLX - MAXGRDX * DIMCEL) / 2;
  int  gmrx = (SCRLX + MAXGRDX * DIMCEL) / 2 - 1;
  int  gmty = ((SCRLY + OFFGRDY) - MAXGRDY * DIMCEL) / 2;
  int  gmby = ((SCRLY + OFFGRDY) + MAXGRDY * DIMCEL) / 2 - 1;

  int  i = 1;
  char *s, *p = pz_in_uso;

  /* colora lo sfondo della griglia di GREEN */
  setfillstyle( SOLID_FILL, GREEN);
  bar(gmlx - OFFGRDLINE, gmty - OFFGRDLINE,
     gmrx + OFFGRDLINE, gmby + OFFGRDLINE);
  InizializeGrid(liv);
  s = livello[liv].np;
  for(i=0; i < NPEZZI; ++i)
    *p++ = *s++;
}

/* ************************************************************************ */
void Stampa_pz_disp ( int doppio )
{
  int i, inc, r;
  char *s = " ", *p;

  inc = (MPZRX - MPZLX) / 12 + 1;

  settextjustify(CENTER_TEXT, BOTTOM_TEXT);
  r = ++doppio;
  for(i = MPZLX, p = pz_in_uso; i < MPZRX; i += inc)
  {
    *s = *p++ + 48;
    Scrivi(i + inc / 2, MPZBY - OF_TXT, "", GREEN);
    Scrivi(i + inc / 2, MPZBY - OF_TXT, s, WHITE);
  }
}

/* ************************************************************************ */
void CancellaVetGrid( void )
{
  int i, w;
  for(i = 0; i < 15; ++i)
    for(w = 0; w < 10; ++w)
      pz_in_grid[i][w].gx_pz = GRID_VUOTA;
}

/* ************************************************************************ */
void  Cambia(void)
{
  int  t,i;
  for(t=0; t < NPEZZI * 8; ++t)
    for(i=0; i < 10; ++i)
      pezzo[t][i] = pezzo[t][i] * DIMCEL;
}

/* ************************************************************************ */
void Inizialize (void)
{
  int   grph_drv, grph_mode;
  int   i = 0;
  char  *s = "by BA";
  char  *tmp;
  char  *old;

  grph_drv = EGA;
  grph_mode = EGAHI;
  initgraph(&grph_drv, &grph_mode, "");
  setviewport(0, 0, SCRLX - 1, SCRLY - 1, 0);
  SettaPagina();
  InizializeGet();
  CreaNumeri();
  cleardevice();

  while (i++ < 2)
  {
    SettaPagina();
    /* colora lo sfondo di GREEN */
    setfillstyle( SOLID_FILL, GREEN);
    bar(0,0, SCRLX -1, SCRLY -1);
    setfillstyle( SOLID_FILL, WHITE);
    bar(0,EXIT_CY, 1, EXIT_CY + 1);

    DrawIntest();
    DrawMirror();
    DrawFlip();
    DrawRotate();
    DrawPiece();
    DrawPezzi();
	DrawPunteggio();
	/* decodifica la stringa by BA */
	tmp = NAMEBA;
	old = s;
	while ( *tmp != '\0' )
	{
		*s = *tmp - (OFF_NAME - 10);
		tmp++;
		s++;
	}
	s = old;
	/* scrive la stringa by BA */
	settextjustify(CENTER_TEXT, BOTTOM_TEXT);
	Scrivi(XFLIP + AMPIEZX /2, (YROTATE + YMIRROR + AMPIEZY + OF_TXT) / 2, s, YELLOW);
  }
  AggiornaDatiPezzo(NO_PEZZO);
  Mouse( MOUS_RESET );
  reg.r_cx = 0;
  reg.r_dx = SCRLX - DIMCEL - 1;
  Mouse( MOUS_RANGEX );
  reg.r_cx = EXIT_CY;
  reg.r_dx = SCRLY - DIMCEL;
  Mouse( MOUS_RANGEY );

}

/* ************************************************************************ */
void Mouse (int  funzione)
{
  reg.r_ax = funzione;
  intr(INT_MOUSE, &reg);
}


/* ************************************************************************ */
/* Scambia le 2 pagine video usate - 1 visualizzata e 1 x stampare
   se ms = 1 pagina attiva e visualizzata = pg */
void SettaPagina( void )
{
  setactivepage( pg );
  pg = ~pg & 1;
  setvisualpage( pg );
}

/* ************************************************************************ */
/* controlla limiti dei pulsanti */
int  ContLim (int px, int py, int cx, int cy)
{
  if (px - cx < AMPIEZX && px > cx  && py - cy < AMPIEZY && py > cy )
     return (1);
  else
     return (0);
}
/* ************************************************************************ */
/* scrive un testo con l'ombra nera */
void Scrivi(int tx, int ty, char *stringa, int color)
{
  if (color != GREEN)
    setcolor(BLACK);
  else
    setcolor(GREEN);
  outtextxy(tx + 3, ty + 3, stringa);
  setcolor(color);
  outtextxy(tx, ty, stringa);
}

/* ************************************************************************ */
void DrawIntest( void )
{
  int   x, y, lx, ly;

  settextjustify(CENTER_TEXT, TOP_TEXT);
  lx = 300;
  ly = INTEST_LY;
  x = (SCRLX - lx) / 2;
  y = INTEST_DY;
  /*  tempo */
  Bottone (x, y, lx, ly, BLUE, 0, AMP_PULS);
  Scrivi(x + lx / 2, y + OF_TXT, "INDICATORE DEL BONUS", LIGHTRED);
  /*  vite */
  lx = 150;
  x = 10;
  Bottone (x, y, lx, ly, BLUE, 0, AMP_PULS);
  Scrivi(x + lx / 2, y + OF_TXT, "VITE", LIGHTRED);
  /*  livelli */
  lx = 150;
  x = SCRLX - (lx + x);
  Bottone (x, y, lx, ly, BLUE, 0, AMP_PULS);
  Scrivi(x + lx / 2, y + OF_TXT, "LIVELLO", LIGHTRED);
}

/* ************************************************************************ */
void DrawMirror( void )
{
  Bottone(XMIRROR, YMIRROR, AMPIEZX, AMPIEZY, MAGENTA, 0, AMP_PULS);
  settextjustify(CENTER_TEXT, BOTTOM_TEXT);
  Scrivi(XMIRROR + AMPIEZX /2, YMIRROR + AMPIEZY - OF_TXT, "SPECCHIO", YELLOW);
  settextjustify(CENTER_TEXT, TOP_TEXT);
  Scrivi(XMIRROR + AMPIEZX /2, YMIRROR + OF_TXT, "SPECCHIO", YELLOW);
  /* disegna freccia */
  setcolor(BLACK);
  moveto(XMIRROR + 20, YMIRROR + AMPIEZY / 2);
  linerel(18, -18);
  linerel(0, 9);
  linerel(54, 0);
  linerel(0, -9);
  linerel(18, 18);
  linerel(-18, 18);
  linerel(0, -9);
  linerel(-54,0);
  linerel(0, 9);
  linerel(-18, -18);
  setfillstyle (SOLID_FILL, LIGHTRED);
  floodfill (XMIRROR + 21, YMIRROR + AMPIEZY / 2, BLACK);
}

/* ************************************************************************ */
#define ROTCX    XROTATE + AMPIEZX / 2
#define ROTCY    YROTATE + 32
void DrawRotate( void )
{
  int triang1[] = {ROTCX - 3, ROTCY - 22,
		   ROTCX + 4, ROTCY - 22 + 7,
		   ROTCX - 3, ROTCY - 22 + 14,
                   ROTCX - 3, ROTCY - 22};
  int triang2[] = {ROTCX + 27, ROTCY - 3,
		   ROTCX + 27 - 7, ROTCY + 4,
		   ROTCX + 27 - 14, ROTCY - 3,
		   ROTCX + 27, ROTCY - 3};
  int triang3[] = {ROTCX + 3, ROTCY + 22,
		   ROTCX - 4, ROTCY + 22 - 7,
		   ROTCX + 3, ROTCY + 22 - 14,
                   ROTCX + 3, ROTCY + 22};
  int triang4[] = {ROTCX - 27, ROTCY + 3,
		   ROTCX - 27 + 7, ROTCY - 4,
		   ROTCX - 27 + 14, ROTCY + 3,
		   ROTCX - 27, ROTCY + 3};

  settextjustify(CENTER_TEXT, BOTTOM_TEXT);
  Bottone(XROTATE, YROTATE, AMPIEZX, AMPIEZY, CYAN, 0, AMP_PULS);
  Scrivi(XROTATE + AMPIEZX / 2, YROTATE + AMPIEZY - OF_TXT, "RUOTA", YELLOW);

  /* disegno */
  setcolor(BLACK);
  setfillstyle (SOLID_FILL, LIGHTRED);
  ellipse (ROTCX, ROTCY, 0, 360, 18, 13);
  ellipse (ROTCX, ROTCY, 0, 360, 23, 18);
  floodfill (ROTCX - 19, ROTCY, BLACK);
  fillpoly(3, triang1);
  drawpoly(4, triang1);
  fillpoly(3, triang2);
  drawpoly(4, triang2);
  fillpoly(3, triang3);
  drawpoly(4, triang3);
  fillpoly(3, triang4);
  drawpoly(4, triang4);
}

/* ************************************************************************ */
void DrawFlip( void )
{
  settextstyle(DEFAULT_FONT, VERT_DIR, 0);
  Bottone(XFLIP, YFLIP, AMPIEZX, AMPIEZY, LIGHTBLUE, 0, AMP_PULS);
  settextjustify(LEFT_TEXT, CENTER_TEXT);
  Scrivi(XFLIP + OF_TXT + 8, YFLIP + AMPIEZY / 2, "FLIP", YELLOW);
  settextjustify(LEFT_TEXT, CENTER_TEXT);
  Scrivi(XFLIP + AMPIEZX - OF_TXT, YFLIP + AMPIEZY / 2, "FLIP", YELLOW);
  settextstyle(DEFAULT_FONT, HORIZ_DIR, 0);
  /* disegna freccia */
  setcolor(BLACK);
  moveto(XFLIP + AMPIEZX / 2, YFLIP + 10);
  linerel(-18, 18);
  linerel(9, 0);
  linerel(0, 20);
  linerel(-9, 0);
  linerel(18, 18);
  linerel(18, -18);
  linerel(-9, 0);
  linerel(0, -20);
  linerel(9, 0);
  linerel(-18, -18);
  setfillstyle (SOLID_FILL, LIGHTRED);
  floodfill (XFLIP + AMPIEZX / 2, YFLIP + 11, BLACK);
}

/* ************************************************************************ */
void DrawPiece( void )
{
  settextjustify(CENTER_TEXT, BOTTOM_TEXT);
  Bottone(XPIECE, YPIECE, AMPIEZX, AMPIEZY, BROWN, 0, AMP_PULS);
  Scrivi(XPIECE + AMPIEZX / 2, YPIECE + AMPIEZY - OF_TXT, "DEPOSITA", YELLOW);
  /* disegna frecce */
  setcolor(BLACK);
  moveto(XPIECE + AMPIEZX / 2, YPIECE + 45);
  linerel(-20, -20);
  linerel(40, 0);
  linerel(-20, 20);
  setfillstyle (SOLID_FILL, LIGHTRED);
  floodfill (XPIECE + AMPIEZX / 2, YPIECE + 44, BLACK);

  moveto(XPIECE + AMPIEZX - 20, YPIECE + 45);
  linerel(-20, 0);
  linerel(20, -20);
  linerel(0, 20);
  floodfill (XPIECE + AMPIEZX - 21, YPIECE + 44, BLACK);

  moveto(XPIECE + 20, YPIECE + 45);
  linerel(20, 0);
  linerel(-20, -20);
  linerel(0, 20);
  floodfill (XPIECE + 21, YPIECE + 44, BLACK);
}

/* ************************************************************************ */
void DrawPezzi( void )
{
  int i, inc;

  settextjustify(CENTER_TEXT, BOTTOM_TEXT);
  setcolor(LIGHTBLUE);
  rectangle (MPZLX, MPZTY, MPZRX, MPZBY);

  inc = (MPZRX - MPZLX) / 12 + 1;
  for(i = MPZLX, pz = 0; i < MPZRX; i += inc, pz++)
  {
    setcolor( LIGHTBLUE );
    line (i, MPZTY, i, MPZBY);
    DisegnaPezzo(i, MPZTY, inc);
  }
}

/* ************************************************************************ */
void  DisegnaPezzo (int x, int y, int inc)
{
  int  i, xp, yp, l;
  int  color[] = {BROWN, LIGHTGRAY, LIGHTBLUE, LIGHTMAGENTA, LIGHTGREEN,
		  RED, CYAN, LIGHTRED, YELLOW, MAGENTA, BLUE, LIGHTCYAN,
		  GREEN}; /* sfondo griglia GREEN = elemento 12 */

  l = DIMCEL / 2 + 1;
  for(i = 0; i < 10; i += 2)
  {
    AggiornaDatiPezzo(pz * 8);
    xp = x + pezzo[pz * 8][i] / 2 + 1;
    yp = y + pezzo[pz * 8][i + 1] / 2 + 10;
    Bottone (xp + inc / 2 - ofx / 2 - 2, yp, l, l, color[pz], 1, AMP_PZ12);
  }
}

/* ************************************************************************ */
void DrawPunteggio( void )
{
  settextjustify(RIGHT_TEXT, TOP_TEXT);
  Scrivi(PUNTEG_X, PUNTEG_Y, "Punteggio: ", LIGHTRED);
  settextjustify(LEFT_TEXT, TOP_TEXT);
  Scrivi(PUNTEG_X, PUNTEG_Y, "0", YELLOW);

}

/* ************************************************************************ */
/* buffer per quadrato e sfondo griglia */
void   *buf[NPEZZI + 1];

/* puntatore ad un buffer per lo sfondo sotto il pezzo */
void   *buf_sf;

/* coordinate precedenti del pezzo */
int   cpx = -1, cpy = -1;

/* ************************************************************************ */
/* memorizza i quadrati con diversi colori */
void InizializeGet (void)
{

  int  dim, i;
  int  color[] = {BROWN, LIGHTGRAY, LIGHTBLUE, LIGHTMAGENTA, LIGHTGREEN,
		  RED, CYAN, LIGHTRED, YELLOW, MAGENTA, BLUE, LIGHTCYAN,
		  GREEN}; /* sfondo griglia GREEN = elemento 12 */

  /* dimensione massima del quadrato */
  dim = imagesize (0, 0, DIMCEL, DIMCEL);

  for (i = 0; i <= NPEZZI; ++i)
  {
    buf[i] = malloc( dim );
    Bottone (0, 0, DIMCEL, DIMCEL, color[i],
     (color[i] != GREEN ? 1 : 0), (color[i] != GREEN ? AMP_PEZZ : AMP_GRID) );
    getimage (0, 0, DIMCEL - 1, DIMCEL - 1, buf[i]);
  }
  /* buffer per contenere lo sfondo in base alla massima larghezza */
  dim = imagesize (0, 0, MAX_X_SF, MAX_Y_SF);
  buf_sf = malloc( dim );

}

/* ************************************************************************ */
/* stampa griglia */
void InizializeGrid (int level)
{
  /* dimensione massime  15*10 */
  int  gmlx = (SCRLX - MAXGRDX * DIMCEL) / 2;
  int  gmrx = (SCRLX + MAXGRDX * DIMCEL) / 2 - 1;
  int  gmty = ((SCRLY + OFFGRDY) - MAXGRDY * DIMCEL) / 2;
  int  gmby = ((SCRLY + OFFGRDY) + MAXGRDY * DIMCEL) / 2 - 1;

  int  ix, iy, lx, ly;

  /* lx e ly ampiezza della griglia in unita' */
  lx = livello[level].lx;
  ly = livello[level].ly;
  /* dimensione max grid - publiche */
  glx = (SCRLX - lx * DIMCEL) / 2;
  grx = (SCRLX + lx * DIMCEL) / 2 - 1;
  gty = ((SCRLY  + OFFGRDY) - ly * DIMCEL) / 2;
  gby = ((SCRLY + OFFGRDY) + ly * DIMCEL) / 2 - 1;

   for (ix = 0; ix < lx * DIMCEL; ix += DIMCEL)
     for (iy = 0; iy < ly * DIMCEL; iy += DIMCEL)
       putimage (glx + ix, gty + iy, buf[12], COPY_PUT);

  setcolor( LIGHTGREEN );
  line (gmlx - OFFGRDLINE, gty - OFFGRDLINE,
	 gmrx + OFFGRDLINE, gty - OFFGRDLINE);
  line (gmlx - OFFGRDLINE, gby + OFFGRDLINE,
	 gmrx + OFFGRDLINE, gby + OFFGRDLINE);
  line (glx - OFFGRDLINE, gmty - OFFGRDLINE,
	 glx - OFFGRDLINE, gmby + OFFGRDLINE);
  line (grx + OFFGRDLINE, gmty - OFFGRDLINE,
	 grx + OFFGRDLINE, gmby + OFFGRDLINE);
  getimage(x, y, x + DIMCEL, y + DIMCEL, buf_sf);
}

/* ************************************************************************ */
void MuoviPezzo( int vis_tempo, int tempo )
/* se pz = NO_PEZZO ripristina sfondo */
{

  /* coordinate precedenti del pezzo
  static int   cpx = -1, cpy = -1; */
  /* pezzo precedente se -1 nessun pezzo */
  static int   ppz = -2, ppos = -1;
  /* se = 1 nuova posizione pezzo */
  static int   npz = 0;
  static int  tx, ty;
  static int  i, pos;

  pos = pz * 8 + rot;
  /* controlla se e' cambiato il pezzo, ed aggiorna l' offset e la lung. */
  if (pos != ppos)
    AggiornaDatiPezzo( pos );

  tx = x - ofx;
  ty = y - ofy;

  /* controllo limiti dello schermo */
  if (tx <= 0)
    tx = 0;
  if (ty <= 0)
    ty = 0;
  if (x + ofx >= SCRLX)
     tx = SCRLX - ofx - ofx;
  if (y + ofy >= SCRLY)
     ty = SCRLY - ofy - ofy;

  if (tx != cpx || ty != cpy || pos != ppos || vis_tempo)
    npz = 1;
  else
    npz = 0;

  if (npz == 1)
  {

    /* aggiorna la visualizzazione del tempo */
    StampaNumeri (COORD_TMX, COORD_TMY, tempo, 2);
    if (pz != NO_PEZZO)
      for (i = 0; i < 10; i += 2)
	putimage (tx + pezzo[pos][i] - plx, ty + pezzo[pos][i + 1] - ply,
		  buf[pz], COPY_PUT);
    else
    {
      setcolor(YELLOW);
      line(tx, ty, tx + DIMCEL, ty + DIMCEL);
      line(tx, ty, tx, ty + DIMCEL);
      line(tx, ty + 9, tx + 8, ty + 9);
    }

    SettaPagina();

    if ( ppz != -2 )
      putimage(cpx, cpy, buf_sf, COPY_PUT);

    if (pos != ppos)
      Stampa_pz_disp(1);
    if ( pz != NO_PEZZO)
      getimage(tx, ty, tx + ofx + ofx - 1, ty + ofy + ofy - 1, buf_sf);
    else
      getimage(tx, ty, tx + DIMCEL, ty + DIMCEL, buf_sf);

    cpx = tx;
    cpy = ty;
    ppz = pz;
    ppos = pos;
  }

}

/* ************************************************************************ */
void Bottone(int bx, int by, int lx, int ly, int color, int ombra,
	     int ampiezza)
/* stampa un singolo bottone con un colore dato
   bx, by coordinate lx, ly ampiezza del bottone */
{
  int i;

 --lx;
 --ly;
 setcolor( color );
 setfillstyle( SOLID_FILL, color);
 bar(bx, by, bx + lx, by + ly);

  if (color > 7)
   color = WHITE;
  else
   color += 8;

 for(i = 0; i < ampiezza; i++)
 {
   setcolor ( ombra == 0 ? BLACK : color );
   line(bx + i, by + ly - 1 - i, bx + i, by + i);
   line(bx + i, by + i, bx + lx - 1 - i, by + i);
   setcolor( ombra == 0 ? color : BLACK);
   line(bx + i, by + ly - i, bx + lx - i, by + ly - i);
   line(bx + lx - i, by + ly - i, bx + lx - i, by + i);
  }


/*  setcolor ( ombra == 0 ? BLACK : color );
 line(bx + 1, by + 1, bx + lx - 1, by + 1);
 line(bx + 1, by + 2, bx + 1, by + ly - 2);
 line(bx + lx - 1, by, bx, by);
 line(bx, by + 1, bx, by + ly - 1);


 setcolor( ombra == 0 ? color : BLACK);
 line(bx + 1, by + ly - 1, bx + lx - 1, by + ly - 1);
 line(bx + lx - 1, by + ly - 2, bx + lx - 1, by + 1);
 line(bx, by + ly, bx + lx, by + ly);
 line(bx + lx, by + ly - 1, bx + lx, by);*/

}

/* ************************************************************************ */
/* Modifica le variabili publiche plx, ply, ofx, ofy */
void AggiornaDatiPezzo( int pos )
{
  int i;

  if (pz == NO_PEZZO)
    ofx = ofy = 0;
  else
  {
    plx = ply = 1000;
    ofx = ofy = DIMCEL;

    for(i = 0; i < 10; i += 2)
    {
      if (pezzo[pos][i] <= plx)
	plx = pezzo[pos][i];

      if (pezzo[pos][i] >= ofx)
	ofx = pezzo[pos][i] + DIMCEL;

      if (pezzo[pos][i + 1] <= ply)
	ply = pezzo[pos][i + 1];

      if (pezzo[pos][i + 1] >= ofy)
	ofy = pezzo[pos][i + 1] + DIMCEL;
    }
    ofx = (ofx - plx) / 2;
    ofy = (ofy - ply) / 2;
  }
}

/* ************************************************************************ */
/* Stampa il pezzo selezionato con un colore dato */
void PrintPezzo(int pez, int colore)
{
 int  i, pos, r = 1;
 int  tx, ty;

 pos = pez * 8 + rot;
 AggiornaDatiPezzo( pos );

 tx = x - ofx;
 ty = y - ofy;

 while (r++ <= 2)
 {
   if (colore == SFONDO)
     putimage(cpx, cpy, buf_sf, COPY_PUT);
   for (i = 0; i < 10; i += 2)
      putimage (tx + pezzo[pos][i] - plx, ty + pezzo[pos][i + 1] - ply,
		buf[colore], COPY_PUT);
   SettaPagina();
 }
 getimage(tx, ty, tx + ofx + ofx - 1, ty + ofy + ofy - 1, buf_sf);
 cpx = tx;
 cpy = ty;
}

/* ************************************************************************ */
/* buffer per numeri */
void  *number[10];

/* ************************************************************************ */
void CreaNumeri( void )
{
  int dim, i, d;

  struct coord {
    int  px;
    int  py;
  } disp[] = {
		{0, 3 + NUM_SDY},
		{0, 8 + NUM_SHY + NUM_SDY * 4},
		{3 + NUM_SDX, 0},
		{3 + NUM_SDX, NUM_SDY + 6 + NUM_SHY + NUM_SDY},
		{3 + NUM_SDX, (NUM_SDY + 6 + NUM_SHY) * 2 + NUM_SDY * 2},
		{6 + NUM_SDX * 2 + NUM_SLX, 3 + NUM_SDY},
		{6 + NUM_SDX * 2 + NUM_SLX, 8 + NUM_SHY + NUM_SDY * 4}
  };

  char  *display[] = {  "\2\2\1\0\1\2\2",
			"\0\0\0\0\0\2\2",
			"\0\2\1\1\1\2\0",
			"\0\0\1\1\1\2\2",
			"\2\0\0\1\0\2\2",
			"\2\0\1\1\1\0\2",
			"\2\2\1\1\1\0\2",
			"\0\0\1\0\0\2\2",
			"\2\2\1\1\1\2\2",
			"\2\0\1\1\1\2\2" };

  dim = imagesize (0, 0,
		   12 + NUM_SLX  + NUM_SDX * 2 + NUM_SOX,
		   18 + (NUM_SHY + NUM_SDY) * 2 + NUM_SDY + NUM_SOY + 1);
  for (i=0; i<10; ++i)
  {
    setcolor(BLUE);
    setfillstyle (SOLID_FILL, BLUE);
    bar (0,0,
		   12 + NUM_SLX  + NUM_SDX * 2 + NUM_SOX,
		   18 + (NUM_SHY + NUM_SDY) * 2 + NUM_SDY + NUM_SOY + 1);

    for(d=0; d<7; ++d)
    {
      if (*display[i] != 0)
	if (*display[i] == 1)
	   DrawSegOrr(disp[d].px, disp[d].py);
	else
	   DrawSegVer(disp[d].px, disp[d].py);
      *display[i]++;
    }
    number[i] = malloc( dim );
    getimage(0,0,
		12 + NUM_SLX  + NUM_SDX * 2 + NUM_SOX,
		18 + (NUM_SHY + NUM_SDY) * 2 + NUM_SDY + NUM_SOY + 1,
		number[i]);
  }
}

/* ************************************************************************ */
/* traccia segmento orrizzontale orrizzontale */
void DrawSegOrr( int px, int py )
{
  int i = 0, color;
  while (++i <= 2)
  {
    if (i == 1)
    {
      moveto(px + NUM_SOX, py + 3 + NUM_SOY);
      color = BLACK;
    }
    else
    {
      moveto(px , py + 3);
      color = GREEN;
    }
    setcolor (color);
    linerel (3, -3);
    linerel (NUM_SLX, 0);
    linerel (3, 3);
    linerel (-3,3);
    linerel (-NUM_SLX, 0);
    linerel (-3, -3);
    setfillstyle (SOLID_FILL, color);
    floodfill (px + 8, py + 4, color);
  }
}

/* ************************************************************************ */
/* traccia segmento orrizzontale orrizzontale */
void DrawSegVer( int px, int py )
{
  int i = 0, color;

  while (++i <= 2)
  {
    if (i == 1)
    {
      moveto(px + 3 + NUM_SOX, py + NUM_SOY);
      color = BLACK;
    }
    else
    {
      moveto(px + 3, py);
      color = GREEN;
    }
    setcolor (color);
    linerel (-3, 3);
    linerel (0, NUM_SHY);
    linerel (3, 3);
    linerel (3, -3);
    linerel (0, -NUM_SHY);
    linerel (-3, -3);
    setfillstyle (SOLID_FILL, color);
    floodfill (px + 4, py + 8, color);
  }
}

/* ************************************************************************ */
/* scrive nuri sullo shermo */
void StampaNumeri (int px, int py, int numero, int num_cifre)
{
  int i, p, c;

  for(i=100, c = 2; i > 0; i/=10, --c)
  {
    p = numero / i;
    numero -= p * i;
    if (c <= num_cifre)
    {
      putimage(px, py, number[p], COPY_PUT);
      px += NUM_DIST;
    }
  }
}

/* ************************************************************************ */
void ModificaPunteggio(int *punteggio, int tempo)
{
  int i, rit;
  char *s;
  div_t d;

  d.quot = tempo;
  settextjustify(LEFT_TEXT, TOP_TEXT);
  for (i = 1; i <= 100; i *=10)
  {
    d = div(d.quot , 10);
    while (d.rem--)
    {
       tempo -= i;
       *punteggio += i;
       StampaNumeri(COORD_TMX, COORD_TMY, tempo, 2);
       itoa(*punteggio, s, 10);
       setcolor(GREEN);
       outtextxy(PUNTEG_X, PUNTEG_Y, "");
       outtextxy(PUNTEG_X + 3, PUNTEG_Y + 3, "");
       Scrivi(PUNTEG_X, PUNTEG_Y, s, YELLOW);
       SettaPagina();
       for(rit = 17000; rit--;)
	 ;
    }
  }
  setcolor(GREEN);
  outtextxy(PUNTEG_X, PUNTEG_Y, "");
  Scrivi(PUNTEG_X, PUNTEG_Y, s, YELLOW);
  StampaNumeri(COORD_TMX, COORD_TMY, tempo, 2);
  sleep(2);
}